from pylabs import q
from vboxapi import VirtualBoxManager

from VBoxHypervisorCMDToolsExceptions import InvalidMachineStateNr
from VBoxHypervisorCMDToolsExceptions import InvalidSessionStateNr

from VirtualboxEnums import VirtualboxMachineStatusType
from VirtualboxEnums import VirtualBoxSessionState

import os
os.chdir(os.environ.get('VBOX_PROGRAM_PATH'))

vbox = VirtualBoxManager(None, None)

__vbox = None

# List of session state enumerations
__sessionStates = [VirtualBoxSessionState.NULL,
                   VirtualBoxSessionState.CLOSED,
                   VirtualBoxSessionState.OPEN,
                   VirtualBoxSessionState.SPAWNING,
                   VirtualBoxSessionState.CLOSING,
                   VirtualBoxSessionState.UNKNOWN]

def getMachineStateEnumFromStateNr(machineStateNr):
    states = q.enumerators.VirtualboxMachineStatusType._pm_enumeration_items
    if machineStateNr < 0 or machineStateNr >= len(states) or not int(machineStateNr) in [int(value) for value in states.values()]:
        raise InvalidMachineStateNr("Invalid machine state number used: %d" %machineStateNr)
    return VirtualboxMachineStatusType.getByName([key for key,value in states.iteritems() if int(value) == int(machineStateNr)][-1])

def getSessionStateEnumFromStateNr(sessionStateNr):
    if sessionStateNr < 0 or sessionStateNr >= len(__sessionStates):
        raise InvalidSessionStateNr("Invalid session state number used: %d" %sessionStateNr)
    return __sessionStates[sessionStateNr]

def getSessionObject():
    mgr = vbox.mgr
    return mgr.getSessionObject(getVirtualBox())

def getVirtualBox():
    global __vbox
    if not __vbox:
        __vbox = vbox.getVirtualBox()
    vbox.waitForEvents(0)
    return __vbox

def getVirtualBoxManager():
    return vbox
