from pylabs.baseclasses.BaseEnumeration import EnumerationWithValue
from pylabs.baseclasses import BaseEnumeration
from pylabs import q

class VirtualboxOsType(EnumerationWithValue):
    """
    Type of operating system running on a Virtualbox machine
    """
    pass

VirtualboxOsType.registerItem('unknown', 'Other')
VirtualboxOsType.registerItem('dos', 'dos')
VirtualboxOsType.registerItem('win31', 'windows31')
VirtualboxOsType.registerItem('win95', 'windows95')
VirtualboxOsType.registerItem('win98', 'windows98')
VirtualboxOsType.registerItem('winme', 'windowsMe')
VirtualboxOsType.registerItem('winnt4', 'windowsnt4')
VirtualboxOsType.registerItem('win2k', 'windows2000')
VirtualboxOsType.registerItem('winxp', 'windowsXp')
VirtualboxOsType.registerItem('winxp_64', 'windowsXp_64')
VirtualboxOsType.registerItem('win2k3', 'windows2003')
VirtualboxOsType.registerItem('win2k3_64', 'windows2003_64')
VirtualboxOsType.registerItem('winvista', 'windowsvista')
VirtualboxOsType.registerItem('winvista_64', 'windowsvista_64')
VirtualboxOsType.registerItem('win2k8', 'windows2008')
VirtualboxOsType.registerItem('win2k8_64', 'windows2008_64')
VirtualboxOsType.registerItem('win7', 'windows7')
VirtualboxOsType.registerItem('win7_64', 'windows7_64')
VirtualboxOsType.registerItem('os2warp3', 'os2warp3')
VirtualboxOsType.registerItem('os2warp4', 'os2warp4')
VirtualboxOsType.registerItem('os2warp45', 'os2warp45')
VirtualboxOsType.registerItem('linux', 'linux')
VirtualboxOsType.registerItem('linux22', 'linux22')
VirtualboxOsType.registerItem('linux24', 'linux24')
VirtualboxOsType.registerItem('linux24_64', 'linux24_64')
VirtualboxOsType.registerItem('linux26', 'linux26')
VirtualboxOsType.registerItem('linux26_64', 'linux26_64')
VirtualboxOsType.registerItem('archlinux', 'archlinux')
VirtualboxOsType.registerItem('archlinux_64', 'archlinux_64')
VirtualboxOsType.registerItem('debian', 'debian')
VirtualboxOsType.registerItem('debian_64', 'debian_64')
VirtualboxOsType.registerItem('opensuse', 'opensuse')
VirtualboxOsType.registerItem('opensuse_64', 'opensuse_64')
VirtualboxOsType.registerItem('fedoracore', 'fedora')
VirtualboxOsType.registerItem('fedoracore_64', 'fedora_64')
VirtualboxOsType.registerItem('gentoo', 'gentoo')
VirtualboxOsType.registerItem('gentoo_64', 'gentoo_64')
VirtualboxOsType.registerItem('mandriva', 'mandriva')
VirtualboxOsType.registerItem('mandriva_64', 'mandriva_64')
VirtualboxOsType.registerItem('redhat', 'redhat')
VirtualboxOsType.registerItem('redhat_64', 'redhat_64')
VirtualboxOsType.registerItem('ubuntu', 'ubuntu')
VirtualboxOsType.registerItem('ubuntu_64', 'ubuntu_64')
VirtualboxOsType.registerItem('xandros', 'xandros')
VirtualboxOsType.registerItem('xandros_64', 'xandros_64')
VirtualboxOsType.registerItem('freebsd', 'freebsd')
VirtualboxOsType.registerItem('freebsd_64', 'freebsd_64')
VirtualboxOsType.registerItem('openbsd', 'openbsd')
VirtualboxOsType.registerItem('openbsd_64', 'openbsd_64')
VirtualboxOsType.registerItem('netbsd', 'netbsd')
VirtualboxOsType.registerItem('netbsd_64', 'netbsd_64')
VirtualboxOsType.registerItem('netware', 'netware')
VirtualboxOsType.registerItem('solaris', 'solaris')
VirtualboxOsType.registerItem('solaris_64', 'solaris_64')
VirtualboxOsType.registerItem('l4', 'l4')
VirtualboxOsType.finishItemRegistration()

class VirtualboxMachineStatusType(BaseEnumeration):
    """
    Status of a Virtualbox machine
    """
    def __init__(self, value):
        self.value = value

    def __int__(self):
        return self.value

    def __cmp__(self, other):
        return cmp(int(self), int(other))

    def __repr__(self):
        return str(self)

from vboxapi.VirtualBox_constants import VirtualBoxReflectionInfo
enums = VirtualBoxReflectionInfo(False)

ignoredStates = ['FirstOnline', 'LastOnline', 'LastTransient']
index = 0
for key, value in enums._Values['MachineState'].iteritems():
    if key in ignoredStates:continue
    if key == 'PoweredOff':
        key = 'Stopped'
    VirtualboxMachineStatusType.registerItem(key, value=value)
    index += 1
# Machine state: Unknown
VirtualboxMachineStatusType.registerItem('unknown', value = index + 1)

VirtualboxMachineStatusType.finishItemRegistration()

class VirtualBoxDeviceType(BaseEnumeration):
    """
    Status of a Virtualbox machine
    """
    def __init__(self, value):
        self.value = value

    def __int__(self):
        return self.value

    def __cmp__(self, other):
        return cmp(int(self), int(other))

    def __repr__(self):
        return str(self)
for key, value in enums._Values['DeviceType'].iteritems():
    VirtualBoxDeviceType.registerItem(key, value=value)

VirtualBoxDeviceType.finishItemRegistration()

class VirtualboxNicType(EnumerationWithValue):
    """
    Type of nic drivers supported by Virtualbox
    """
    pass

#VirtualboxNicType.registerItem('Null', value = 0)
VirtualboxNicType.registerItem('Am79C970A', value = 1)
VirtualboxNicType.registerItem('Am79C973', value= 2)
VirtualboxNicType.registerItem('I82540EM', value= 3)
VirtualboxNicType.registerItem('I82543GC', value= 4)
VirtualboxNicType.finishItemRegistration()

class VirtualboxOnOffType(EnumerationWithValue):
    """
    on/off
    """
    pass

VirtualboxOnOffType.registerItem('on', value='on')
VirtualboxOnOffType.registerItem('off', value='off')
VirtualboxOnOffType.finishItemRegistration()

class VirtualboxOnOffDefaultType(EnumerationWithValue):
    """
    on/off/default
    """
    pass

VirtualboxOnOffDefaultType.registerItem('on', value='on')
VirtualboxOnOffDefaultType.registerItem('off', value='off')
VirtualboxOnOffDefaultType.registerItem('default', value='default')
VirtualboxOnOffDefaultType.finishItemRegistration()

class VirtualboxBiosBootMenuType(EnumerationWithValue):
    """
    Options for a machine's boot menu
    """
    pass

VirtualboxBiosBootMenuType.registerItem('disabled', value='disabled')
VirtualboxBiosBootMenuType.registerItem('menuonly', value='menuonly')
VirtualboxBiosBootMenuType.registerItem('messageandmenu', value='messageandmenu')
VirtualboxBiosBootMenuType.finishItemRegistration()


class VirtualboxBootDeviceType(EnumerationWithValue):
    """
    Options for a machine's boot device order
    """
    pass

VirtualboxBootDeviceType.registerItem('none', value='none')
VirtualboxBootDeviceType.registerItem('floppy', value='floppy')
VirtualboxBootDeviceType.registerItem('dvd', value='dvd')
VirtualboxBootDeviceType.registerItem('disk', value='disk')
VirtualboxBootDeviceType.registerItem('net', value='net')
VirtualboxBootDeviceType.finishItemRegistration()


class VirtualboxHardDriveType(EnumerationWithValue):
    """
    Options for VirtualBox hard drive types
    """
    pass

VirtualboxHardDriveType.registerItem('primarymaster', value = 0)
VirtualboxHardDriveType.registerItem('primaryslave', value = 1)
VirtualboxHardDriveType.registerItem('secondaryslave', value = 2)
VirtualboxHardDriveType.finishItemRegistration()


class VirtualboxDiskType(EnumerationWithValue):
    """
    Option for VirtualBox Disk types
    """
    pass

VirtualboxDiskType.registerItem('harddiskimage', 'hdi')
VirtualboxDiskType.registerItem('iscsitarget', 'iscsi')
VirtualboxDiskType.registerItem('vmdk', 'vmdk')
VirtualboxDiskType.registerItem('vdi', 'vdi')
VirtualboxDiskType.finishItemRegistration()

class VirtualboxNetworkingMod(EnumerationWithValue):
    """
    Option for Virtual box supported Networking modes
    """
    pass
VirtualboxNetworkingMod.registerItem('notattached', value = 0)
VirtualboxNetworkingMod.registerItem('nat', value = 1)
VirtualboxNetworkingMod.registerItem('bridged', value = 2)
VirtualboxNetworkingMod.registerItem('intnet', value = 3)
VirtualboxNetworkingMod.registerItem('hostif', value = 4)
VirtualboxNetworkingMod.finishItemRegistration()

class VirtualboxMediumType(EnumerationWithValue):
    """
    Options for a Virtualbox medium type
    """
    pass

VirtualboxMediumType.registerItem('floppy', value='floppy')
VirtualboxMediumType.registerItem('dvd', value='dvd')
VirtualboxMediumType.registerItem('disk', value='disk')
VirtualboxMediumType.finishItemRegistration()

class VirtualBoxSessionState(EnumerationWithValue):
    """
    An enumeration for VBox session states.
    """
    pass

# State Null, never used by the APIs but listed in the SDKRef guide.
VirtualBoxSessionState.registerItem("null", value = 0)

# State Closed.
VirtualBoxSessionState.registerItem("closed", value = 1)

# State Open.
VirtualBoxSessionState.registerItem("open", value = 2)

# State Spawning.
VirtualBoxSessionState.registerItem("spawning", value = 3)

# State Closing.
VirtualBoxSessionState.registerItem("closing", value = 4)

# State Unknown.
VirtualBoxSessionState.registerItem("unknown", value = 5)

VirtualBoxSessionState.finishItemRegistration()


class VirtualBoxAccessMode(EnumerationWithValue):
    """
    Options for VirtualBox access mode
    """
    pass

VirtualBoxAccessMode.registerItem('readonly', value = 1)
VirtualBoxAccessMode.registerItem('readwrite', value = 2)
VirtualBoxAccessMode.finishItemRegistration()

class VirtualBoxLockType(EnumerationWithValue):
    """
    Options for VirtualBox lock type
    """
    pass

VirtualBoxLockType.registerItem('shared', value = 1)
VirtualBoxLockType.registerItem('write', value = 2)
VirtualBoxLockType.finishItemRegistration()

class VirtualBoxFrontEndType(EnumerationWithValue):
    """
    Options for VirtualBox front-end type
    """
    pass

VirtualBoxFrontEndType.registerItem('gui', value = 'gui')
VirtualBoxFrontEndType.registerItem('headless', value = 'headless')
VirtualBoxFrontEndType.registerItem('sdl', value = 'sdl')
VirtualBoxFrontEndType.finishItemRegistration()

class VirtualBoxCleanupModeType(EnumerationWithValue):
    """
    Options for VirtualBox cleanup mode
    """
    pass

VirtualBoxCleanupModeType.registerItem('unregisteronly', value = 1)
VirtualBoxCleanupModeType.registerItem('detachallreturnnone', value = 2)
VirtualBoxCleanupModeType.registerItem('detachallreturnharddisksonly', value = 3)
VirtualBoxCleanupModeType.registerItem('full', value = 4)
VirtualBoxCleanupModeType.finishItemRegistration()

class VirtualBoxSessionStateType(EnumerationWithValue):
    """
    Options for Virtualbox sessionstate
    """
    pass

VirtualBoxSessionStateType.registerItem('null', value = 0)
VirtualBoxSessionStateType.registerItem('unlocked', value = 1)
VirtualBoxSessionStateType.registerItem('locked', value = 2)
VirtualBoxSessionStateType.registerItem('spawing', value = 3)
VirtualBoxSessionStateType.registerItem('unlocking', value = 4)
VirtualBoxSessionStateType.finishItemRegistration()

class VirtualBoxUSBDeviceState(EnumerationWithValue):
    """
    Options for Virtualbox USBDeviceState
    """
    pass

VirtualBoxUSBDeviceState.registerItem('notsupported', value = 0)
VirtualBoxUSBDeviceState.registerItem('unavailable', value = 1)
VirtualBoxUSBDeviceState.registerItem('busy', value = 2)
VirtualBoxUSBDeviceState.registerItem('available', value = 3)
VirtualBoxUSBDeviceState.registerItem('held', value = 4)
VirtualBoxUSBDeviceState.registerItem('captured', value = 5)
VirtualBoxUSBDeviceState.finishItemRegistration()